︠c43a60e2-3496-4e22-a218-61580f294933s︠
#Mini-project: Euler's line
reset
︡06631ae8-fb1d-49e0-80a5-31b02300ffa4︡{"stdout":"<function reset at 0x7f127d4c20c8>\n"}︡{"done":true}
︠e7bcc448-b6d6-406d-b7ea-224f6363634ds︠
#Part 1

#Center of mass of a triangle
#//Imput:?
#//Output:?
def center_of_mass(z1,z2,z3):# triangle ABC: C(z3),B(z2),A(z1);format:z=a+b*I
    m23=(z3+z2)/2 #Find the midpoint of AB
    # Use the remark from Lecture notes to calculate the center of mass
    cm=z1+(2/3)*(m23-z1)
    return [cm.real(),cm.imag()]
︡0e2de17a-0c8a-4f8f-a49d-488342650616︡{"done":true}
︠554a5678-0220-4521-8bed-fac94bed6927s︠
#Example 
#Triangle ABC; A(u,v),B(a,0),C(0,0)
var('u v a');assume(u,'real');assume(v,'real');assume(a,'real');
︡4e1c061b-fdba-4dc2-acc6-c424f90b4d14︡{"stdout":"(u, v, a)\n"}︡{"done":true}
︠2f18428c-6d0b-4100-8c00-7c4532b7f717s︠
center_of_mass(u+v*I,a+0*I,0+0*I)
︡9d54eab1-6856-4174-a609-85f2b1b30614︡{"stdout":"[1/3*a + 1/3*u, 1/3*v]\n"}︡{"done":true}
︠de1a4b67-cd3b-48a5-82ed-dd648022a955s︠
#Useful command: solving system of two linear equations
#solve?
#Example
sol=solve([2.3*x-3.*y+1.1==0.0,x+y-2.5==0.0],x,y,solution_dict=true);sol
︡fd8b89ad-961e-4b27-b6b5-b97ee4cf1a5d︡{"stdout":"[{y: 137/106, x: 64/53}]\n"}︡{"done":true}
︠06979c5e-5383-4448-aec7-a4562a00c634s︠
[sol[0][x],sol[0][y]] #This is how you can access the solution values and make a list of these values
︡2b9ce4ed-0802-404b-a638-5a2ed746a602︡{"stdout":"[64/53, 137/106]\n"}︡{"done":true}
︠7122e6c8-7698-4546-a09f-66ed9581ada9s︠
#Useful function: line_eq(z,S) returns the lhs of the equation a*(x-x0)+b(y-y0)=0 of the line passing through a point z=x0+i*y0 and having normal [a,b]
def line_eq(z,n):
    return n[0]*(x-z.real())+n[1]*(y-z.imag())
︡d642a2a6-dfb0-457b-ba2d-3bac4f8f5189︡{"done":true}
︠3055ece2-82d8-43a8-8705-12d13782f49ds︠
var('x y')
︡598597b2-2a1e-4079-a3ad-40122d18c6bf︡{"stdout":"(x, y)\n"}︡{"done":true}
︠40c43e53-0f2e-454b-9a9a-4436095c2dads︠
#Example
line_eq(3+2*I,[3,-2])
︡b0f47fbd-42df-4f50-a7e0-b1986e0fdeee︡{"stdout":"3*x - 2*y - 5\n"}︡{"done":true}
︠4bbe09ca-dd5e-4f41-9447-875f07d54b7es︠
#Orthocenter
def orthocenter(z1,z2,z3): #left hand sides of eqs of two heights of the triangle
    s23=z3-z2; n1=[s23.real(),s23.imag()]#encode coordinates of a normal of the height from point z1
    expr1=line_eq(z1,n1) # lhs of eq of height from vertex z1
    s13=z3-z1; n2=[s13.real(),s13.imag()]  #encode coordinated of a normal of the height from point z2
    expr2=line_eq(z2,n2) # lhs of eq of height from vertex z2
    sol=solve([expr1==0,expr2==0],x,y,solution_dict=True)  #Orthocenter coordinates
    return [sol[0][x], sol[0][y]]
︡a8172b76-4d9f-4e05-8497-7b2369cfbd95︡{"done":true}
︠94609eb1-74da-4f54-af28-53667551684cs︠
pt1=5+3*I;pt2=4+0*I;pt3=0+0*I
︡7ed615de-0338-4bd3-8b1e-b5cae95b5043︡{"done":true}
︠dbeb547c-fe33-405d-889f-d66f8988b48as︠
O=orthocenter(pt1,pt2,pt3);O
︡b832c78e-b926-4c45-88f5-2d6574727610︡{"stdout":"[5, -5/3]\n"}︡{"done":true}
︠37a60237-b861-4220-926b-cf36b6f06175s︠
#Center of circumscribed circle
def bisector_cross(z1,z2,z3):
    m23=(z3+z2)/2
    s23=z3-z2; n1=[s23.real(),s23.imag()] #Normal to bicector erected from the midpoint of the side connecting z3 and z2
    expr1=line_eq(m23,n1)
    m13=(z1+z3)/2
    s13=z3-z1;n2=[s13.real(),s13.imag()]  #Normal to bicector erected from the midpoint of the side connecting z3 and z1
    expr2=line_eq(m13,n2)
    sol=solve([expr1==0,expr2==0],x,y,solution_dict=True)#Coordinates of the bisector intersection
    return [sol[0][x], sol[0][y]]
︡de84f338-bcfe-456c-8883-b2ea61409376︡{"done":true}
︠c546c63d-0778-4428-9914-d73a4e59f8c6︠
#Part 2.
#(a) Show manually that the three special points of the triangle ABC with A=pt1, B=pt2, C=pt3,lie on a line
︡6d388a3d-7483-4d63-852d-259dd53b0201︡
︠aaafea2d-83d5-4223-8e8c-8b32b029fb45s︠
var('A B C')
︡5b6314ce-ea12-401b-a667-9c66e6d44712︡{"stdout":"(A, B, C)\n"}︡{"done":true}
︠46013c33-0160-443a-9fe7-071332cd130b︠
#C=bisector_cross(pt1,pt2,pt3);C
︡6b19919e-3a99-450b-9bac-ad7f44809162︡
︠c9104b8f-668c-4d96-b524-9a406e371e25s︠
pt1=5+3*I;pt2=4+0*I;pt3=0+0*I

B=bisector_cross(pt1,pt2,pt3);B
︡f7766e80-0424-4647-a2b3-91be61935b12︡{"stdout":"[2, 7/3]\n"}︡{"done":true}
︠4a9b5a2f-d15e-42bc-bba1-56c55840db39︠
#M=center_of_mass(pt1,pt2,pt3);M
︡4796cdde-f4b6-46cc-b567-3f9a1adc6cff︡
︠63cf16cf-84dd-45ed-aa0d-5ce55f64b1cfs︠
pt1=5+3*I;pt2=4+0*I;pt3=0+0*I

M=center_of_mass(pt1,pt2,pt3);M
︡5d55c69a-3df3-41a2-bf84-34e6202a80be︡{"stdout":"[3, 1]\n"}︡{"done":true}
︠a4763489-df69-4cd9-b5db-e88141b4f9bd︠
#H=orthocenter(pt1,pt2,pt3);H
︡19dbc00b-2240-46af-87e2-504e0605db90︡
︠8887460e-e0c5-41ab-b926-d750ed8057ffs︠
pt1=5+3*I;pt2=4+0*I;pt3=0+0*I

O=orthocenter(pt1,pt2,pt3);O
︡e3f90914-ef5b-4acb-98d1-26e1a63443b1︡{"stdout":"[5, -5/3]\n"}︡{"done":true}
︠c7a23214-daca-41c5-82c3-27ff4e234030︠
#(b) Prove that the special points of the triangle ABC with A=u+I*v, B=a, C=0+0*I,lie on a line
︡fcafafd8-57d6-4f19-a6ba-e15d0065ff9a︡
︠32f87055-8847-4024-86f3-e334c5bab733s︠
var('u v a');assume(u,'real');assume(v,'real');assume(a,'real');
︡2be02076-303b-40fb-a906-6586cc6506e7︡{"stdout":"(u, v, a)\n"}︡{"done":true}
︠6f30e8c3-2877-4770-8db2-e35c90ee78b8s︠
A=u+I*v; B=a+I*0; C=0+0*I
︡ba1c44ee-08cd-42d7-bf96-f39920263046︡{"done":true}
︠08a8a44a-9c94-4adc-a4f6-4f972ff88c2a︠
Find the center of mass,cm, the orthocenter,oc, and the bisector intercection,bc
︡b0aa2649-714e-4aaf-8544-b24889522601︡
︠2ef972df-2b1c-45d0-89b4-391d8efb732bs︠
cm=M=center_of_mass(A,B,C);M
oc=O=orthocenter(A,B,C);O
bc=B=bisector_cross(A,B,C);B
︡e0540934-7628-421e-9762-267c32cefd0c︡{"stdout":"[1/3*a + 1/3*u, 1/3*v]\n"}︡{"stdout":"[u, (a*u - u^2)/v]\n"}︡{"stdout":"[1/2*a, -1/2*(a*u - u^2 - v^2)/v]\n"}︡{"done":true}
︠fa69b060-a939-4e83-b73f-33f8117bd6c8s︠

#Part 3: Plotting
# Use command 'point' to plot the three points
# Use command 'line' to plot Euler's line
# Use command polygon2d for plotting the triangle ABC. Choose any coordinates for the vertices provided the vertices do not lie on a line.
#Show all three plots in one figure. Add legend to the line if you want.
︡2e89cd15-5b7e-4133-a24c-9b4bae1699ac︡{"done":true}
︠6670f0fe-8881-4053-a82d-3840770f5006s︠
var('a')
var('b')
var('c')
︡e651a3a1-5afb-4642-9848-ae3212260028︡{"stdout":"a\n"}︡{"stdout":"b\n"}︡{"stdout":"c\n"}︡{"done":true}
︠7121c6ff-b0df-486c-8bac-cd98fe03f4b1︠
#Line through two points, cm and oc
z=[1/3*a + 1/3*u, 1/3*v] #convert the center of mass into complex number
S=[oc[0]-cm[0],oc[1]-cm[1]]#Find a direction vector of the line
n=[?,?]# Find a normal to the line
euler=line_eq(?,?);euler #lhs of the line equation
︡6632348f-597f-4118-9738-80f8787e702b︡
︠474fd885-83e8-42f5-a911-7d703ca16cbb︠
test=euler.subs(x=?,y=?)# Check if the line passes through the intersection of bisectors
︡50e31e62-14fc-489e-a126-e73315354ebe︡
︠ff914a14-37f9-4f4e-b5b6-2d034507b783︠
test.expand()
︡2f59dc27-970a-409f-9f0a-dbebc685fc0b︡
︠8f9c48a6-e6b0-4777-b73a-4fc6679a7d30︠
#Part 3: Plotting
# Use command 'point' to plot the three points
# Use command 'line' to plot Euler's line
# Use command polygon2d for plotting the triangle ABC. Choose any coordinates for the vertices provided the vertices do not lie on a line.
#Show all three plots in one figure. Add legend to the line if you want.
︡9d632088-f1e1-4ecf-a595-4321fbc54ed5︡
︠31d48c62-35d3-47b5-97ed-4b7793634b10s︠
pt_plot=point(a,size=30,color='red',figsize=[4,4],legend_label=a)
pt_plot=point(b,size=30,color='green',figsize=[4,4],legend_label=b)
pt_plot=point(c,size=30,color='blue',figsize=[4,4],legend_label=c)
triangle=polygon2d([[z1.real(),z1.imag()],[z2.real(),z2.imag()],[z2.real(),z2.imag()]],fill=False)
d=line([a,b,c],color='red',legend_label='Eulers line')
show(pt_plot+pt_plot1+pt_plot2+triangle+d)
pt1=5+4*I;
pt2=4+3*I;
pt3=3+2*I
plotting_euler(pt1,pt2,pt3)
plotting_euler(4+2*I,5+3*I,1+4*I)
︡14c95d86-e348-4ce9-a17d-e282888631fd︡{"stderr":"Error in lines 4-4\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1191, in execute\n    flags=compile_flags), namespace, locals)\n  File \"\", line 1, in <module>\nNameError: name 'z1' is not defined\n"}︡{"done":true}
︠8ad06a7b-5b18-45bf-93a5-739137fe0819︠












